/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the MessageButton type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageButton{}

// MessageButton struct for MessageButton
type MessageButton struct {
	Id string `json:"id"`
	Payload *string `json:"payload,omitempty"`
	Type MessageButtonType `json:"type"`
	// Id of text asset
	TextId string `json:"text_id"`
	// Id of text asset
	DescriptionId *string `json:"description_id,omitempty"`
	UrlOptions *MessageButtonUrlOptions `json:"url_options,omitempty"`
}

// NewMessageButton instantiates a new MessageButton object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageButton(id string, type_ MessageButtonType, textId string) *MessageButton {
	this := MessageButton{}
	this.Id = id
	this.Type = type_
	this.TextId = textId
	return &this
}

// NewMessageButtonWithDefaults instantiates a new MessageButton object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageButtonWithDefaults() *MessageButton {
	this := MessageButton{}
	return &this
}

// GetId returns the Id field value
func (o *MessageButton) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *MessageButton) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *MessageButton) SetId(v string) {
	o.Id = v
}

// GetPayload returns the Payload field value if set, zero value otherwise.
func (o *MessageButton) GetPayload() string {
	if o == nil || IsNil(o.Payload) {
		var ret string
		return ret
	}
	return *o.Payload
}

// GetPayloadOk returns a tuple with the Payload field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageButton) GetPayloadOk() (*string, bool) {
	if o == nil || IsNil(o.Payload) {
		return nil, false
	}
	return o.Payload, true
}

// HasPayload returns a boolean if a field has been set.
func (o *MessageButton) HasPayload() bool {
	if o != nil && !IsNil(o.Payload) {
		return true
	}

	return false
}

// SetPayload gets a reference to the given string and assigns it to the Payload field.
func (o *MessageButton) SetPayload(v string) {
	o.Payload = &v
}

// GetType returns the Type field value
func (o *MessageButton) GetType() MessageButtonType {
	if o == nil {
		var ret MessageButtonType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *MessageButton) GetTypeOk() (*MessageButtonType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *MessageButton) SetType(v MessageButtonType) {
	o.Type = v
}

// GetTextId returns the TextId field value
func (o *MessageButton) GetTextId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TextId
}

// GetTextIdOk returns a tuple with the TextId field value
// and a boolean to check if the value has been set.
func (o *MessageButton) GetTextIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TextId, true
}

// SetTextId sets field value
func (o *MessageButton) SetTextId(v string) {
	o.TextId = v
}

// GetDescriptionId returns the DescriptionId field value if set, zero value otherwise.
func (o *MessageButton) GetDescriptionId() string {
	if o == nil || IsNil(o.DescriptionId) {
		var ret string
		return ret
	}
	return *o.DescriptionId
}

// GetDescriptionIdOk returns a tuple with the DescriptionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageButton) GetDescriptionIdOk() (*string, bool) {
	if o == nil || IsNil(o.DescriptionId) {
		return nil, false
	}
	return o.DescriptionId, true
}

// HasDescriptionId returns a boolean if a field has been set.
func (o *MessageButton) HasDescriptionId() bool {
	if o != nil && !IsNil(o.DescriptionId) {
		return true
	}

	return false
}

// SetDescriptionId gets a reference to the given string and assigns it to the DescriptionId field.
func (o *MessageButton) SetDescriptionId(v string) {
	o.DescriptionId = &v
}

// GetUrlOptions returns the UrlOptions field value if set, zero value otherwise.
func (o *MessageButton) GetUrlOptions() MessageButtonUrlOptions {
	if o == nil || IsNil(o.UrlOptions) {
		var ret MessageButtonUrlOptions
		return ret
	}
	return *o.UrlOptions
}

// GetUrlOptionsOk returns a tuple with the UrlOptions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageButton) GetUrlOptionsOk() (*MessageButtonUrlOptions, bool) {
	if o == nil || IsNil(o.UrlOptions) {
		return nil, false
	}
	return o.UrlOptions, true
}

// HasUrlOptions returns a boolean if a field has been set.
func (o *MessageButton) HasUrlOptions() bool {
	if o != nil && !IsNil(o.UrlOptions) {
		return true
	}

	return false
}

// SetUrlOptions gets a reference to the given MessageButtonUrlOptions and assigns it to the UrlOptions field.
func (o *MessageButton) SetUrlOptions(v MessageButtonUrlOptions) {
	o.UrlOptions = &v
}

func (o MessageButton) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageButton) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	if !IsNil(o.Payload) {
		toSerialize["payload"] = o.Payload
	}
	toSerialize["type"] = o.Type
	toSerialize["text_id"] = o.TextId
	if !IsNil(o.DescriptionId) {
		toSerialize["description_id"] = o.DescriptionId
	}
	if !IsNil(o.UrlOptions) {
		toSerialize["url_options"] = o.UrlOptions
	}
	return toSerialize, nil
}

type NullableMessageButton struct {
	value *MessageButton
	isSet bool
}

func (v NullableMessageButton) Get() *MessageButton {
	return v.value
}

func (v *NullableMessageButton) Set(val *MessageButton) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageButton) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageButton) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageButton(val *MessageButton) *NullableMessageButton {
	return &NullableMessageButton{value: val, isSet: true}
}

func (v NullableMessageButton) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageButton) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


